diff --git a/web/pgadmin/browser/__init__.py b/web/pgadmin/browser/__init__.py
index 7fe8fed80..084fb178a 100644
--- a/web/pgadmin/browser/__init__.py
+++ b/web/pgadmin/browser/__init__.py
@@ -487,7 +487,7 @@ class BrowserPluginModule(PgAdminModule):
         browser tree.
         """
         obj = {
-            "id": "%s/%s" % (node_type, node_id),
+            "id": "%s_%s" % (node_type, node_id),
             "label": label,
             "icon": icon,
             "inode": inode,
diff --git a/web/pgadmin/browser/collection.py b/web/pgadmin/browser/collection.py
index 4155061a3..5b29b9b54 100644
--- a/web/pgadmin/browser/collection.py
+++ b/web/pgadmin/browser/collection.py
@@ -90,7 +90,7 @@ class CollectionNodeModule(PgAdminModule, PGChildModule):
             self, node_id, parent_id, label, icon, **kwargs
     ):
         obj = {
-            "id": "%s/%s" % (self.node_type, node_id),
+            "id": "%s_%s" % (self.node_type, node_id),
             "label": label,
             "icon": self.node_icon if not icon else icon,
             "inode": self.node_inode
@@ -107,7 +107,7 @@ class CollectionNodeModule(PgAdminModule, PGChildModule):
 
     def generate_browser_collection_node(self, parent_id, **kwargs):
         obj = {
-            "id": "coll-%s/%d" % (self.node_type, parent_id),
+            "id": "coll-%s_%d" % (self.node_type, parent_id),
             "label": self.collection_label,
             "icon": self.collection_icon,
             "inode": True,
diff --git a/web/pgadmin/browser/server_groups/servers/databases/publications/static/js/publication.js b/web/pgadmin/browser/server_groups/servers/databases/publications/static/js/publication.js
index 30b2705a9..9820711c9 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/publications/static/js/publication.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/publications/static/js/publication.js
@@ -134,7 +134,7 @@ define('pgadmin.node.publication', [
 
         canCreate: function(itemData, item) {
 
-          var treeData = this.getTreeNodeHierarchy(item),
+          var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
             server = treeData['server'];
 
           // If server is less than 10 then do not allow 'create' menu
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/static/js/procedure.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/static/js/procedure.js
index ad9d9a46f..b83401c4c 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/static/js/procedure.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/static/js/procedure.js
@@ -80,7 +80,7 @@ define('pgadmin.node.procedure', [
         ]);
       },
       canCreateProc: function(itemData, item) {
-        var node_hierarchy = this.getTreeNodeHierarchy.apply(this, [item]);
+        var node_hierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
 
         // Do not provide Create option in catalog
         if ('catalog' in node_hierarchy)
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/static/js/trigger_function.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/static/js/trigger_function.js
index e70b17956..95a3c5e63 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/static/js/trigger_function.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/functions/static/js/trigger_function.js
@@ -43,7 +43,7 @@ define('pgadmin.node.trigger_function', [
       label: gettext('Trigger function'),
       collection_type: 'coll-trigger_function',
       canEdit: function(itemData, item) {
-        let node = pgBrowser.treeMenu.findNodeByDomElement(item);
+        let node = pgBrowser.tree.findNodeByDomElement(item);
 
         if (!node || node.parentNode.getData()._type === 'trigger')
           return false;
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/packages/static/js/package.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/packages/static/js/package.js
index 94c34b29a..811a76745 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/packages/static/js/package.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/packages/static/js/package.js
@@ -78,7 +78,7 @@ define('pgadmin.node.package', [
         if (data && data.check == false)
           return true;
 
-        var treeData = this.getTreeNodeHierarchy(item),
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
           server = treeData['server'];
 
         if (server && server.server_type === 'pg')
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js
index 46e01185d..dbc1e86d7 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js
@@ -409,7 +409,7 @@ define('pgadmin.node.schema', [
     });
 
     pgBrowser.tableChildTreeNodeHierarchy = function(i) {
-      return this.getTreeNodeHierarchy(i);
+      return pgBrowser.tree.getTreeNodeHierarchy(i);
     };
   }
 
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema_child_tree_node.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema_child_tree_node.js
index d62c7f297..f4e107234 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema_child_tree_node.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema_child_tree_node.js
@@ -7,7 +7,9 @@
 //
 /////////////////////////////////////////////////////////////
 
-import * as pgBrowser from 'pgbrowser/browser';
+import pgAdmin from 'sources/pgadmin';
+
+let pgBrowser = pgAdmin.Browser;
 
 export function childCreateMenuEnabled(itemData, item, data) {
   // If check is false then , we will allow create menu
@@ -15,7 +17,7 @@ export function childCreateMenuEnabled(itemData, item, data) {
     return true;
   }
 
-  let node = pgBrowser.treeMenu.findNodeByDomElement(item);
+  let node = pgBrowser.tree.findNodeByDomElement(item);
 
   if (node)
     return node.anyFamilyMember(
@@ -26,7 +28,7 @@ export function childCreateMenuEnabled(itemData, item, data) {
 }
 
 export function isTreeItemOfChildOfSchema(itemData, item) {
-  let node = pgBrowser.treeMenu.findNodeByDomElement(item);
+  let node = pgBrowser.tree.findNodeByDomElement(item);
 
   if (node)
     return isTreeNodeOfSchemaChild(node);
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/synonyms/static/js/synonym.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/synonyms/static/js/synonym.js
index 36749506f..5fd3b3283 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/synonyms/static/js/synonym.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/synonyms/static/js/synonym.js
@@ -152,7 +152,7 @@ define('pgadmin.node.synonym', [
         if (data && data.check == false)
           return true;
 
-        var treeData = this.getTreeNodeHierarchy(item),
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
           server = treeData['server'];
 
         if (server && server.server_type === 'pg')
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.js
index e526302ff..ef27c57fd 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.js
@@ -41,7 +41,7 @@ define('pgadmin.node.column', [
       sqlCreateHelp: 'sql-altertable.html',
       dialogHelp: url_for('help.static', {'filename': 'column_dialog.html'}),
       canDrop: function(itemData, item){
-        let node = pgBrowser.treeMenu.findNodeByDomElement(item);
+        let node = pgBrowser.tree.findNodeByDomElement(item);
 
         if (!node)
           return false;
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/compound_triggers/static/js/compound_trigger.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/compound_triggers/static/js/compound_trigger.js
index 783af99d0..cac03d252 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/compound_triggers/static/js/compound_trigger.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/compound_triggers/static/js/compound_trigger.js
@@ -108,7 +108,7 @@ define('pgadmin.node.compound_trigger', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -146,7 +146,7 @@ define('pgadmin.node.compound_trigger', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -206,7 +206,7 @@ define('pgadmin.node.compound_trigger', [
         if (data && data.check == false)
           return true;
 
-        var treeData = this.getTreeNodeHierarchy(item),
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
           server = treeData['server'];
 
         if (server && (server.server_type === 'pg' || server.version < 120000))
@@ -221,7 +221,7 @@ define('pgadmin.node.compound_trigger', [
       },
       // Check to whether trigger is disable ?
       canCreate_with_compound_trigger_enable: function(itemData, item, data) {
-        var treeData = this.getTreeNodeHierarchy(item);
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item);
         if ('view' in treeData) {
           return false;
         }
@@ -231,7 +231,7 @@ define('pgadmin.node.compound_trigger', [
       },
       // Check to whether trigger is enable ?
       canCreate_with_compound_trigger_disable: function(itemData, item, data) {
-        var treeData = this.getTreeNodeHierarchy(item);
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item);
         if ('view' in treeData) {
           return false;
         }
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/static/js/check_constraint.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/static/js/check_constraint.js
index 1e1454c7d..d10eace47 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/static/js/check_constraint.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/static/js/check_constraint.js
@@ -64,7 +64,7 @@ define('pgadmin.node.check_constraint', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (d) {
             var data = d;
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.js
index 75007f685..2d8bb6076 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.js
@@ -61,7 +61,7 @@ define('pgadmin.node.foreign_key', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (d) {
             var data = d;
@@ -99,7 +99,7 @@ define('pgadmin.node.foreign_key', [
         var t = pgBrowser.tree, i = item, d = itemData, parents = [],
           immediate_parent_table_found = false,
           is_immediate_parent_table_partitioned = false,
-          s_version = this.getTreeNodeHierarchy(i).server.version;
+          s_version = t.getTreeNodeHierarchy(i).server.version;
 
         // To iterate over tree to check parent node
         while (i) {
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/static/js/primary_key.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/static/js/primary_key.js
index 0a44e7958..f95ab632b 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/static/js/primary_key.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/static/js/primary_key.js
@@ -58,7 +58,7 @@ define('pgadmin.node.primary_key', [
         var t = pgBrowser.tree, i = item, d = itemData, parents = [],
           immediate_parent_table_found = false,
           is_immediate_parent_table_partitioned = false,
-          s_version = this.getTreeNodeHierarchy(i).server.version;
+          s_version = t.getTreeNodeHierarchy(i).server.version;
 
         // To iterate over tree to check parent node
         while (i) {
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/static/js/unique_constraint.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/static/js/unique_constraint.js
index d018959ed..7b2a8fe87 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/static/js/unique_constraint.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/index_constraint/static/js/unique_constraint.js
@@ -57,7 +57,7 @@ define('pgadmin.node.unique_constraint', [
         var t = pgBrowser.tree, i = item, d = itemData, parents = [],
           immediate_parent_table_found = false,
           is_immediate_parent_table_partitioned = false,
-          s_version = this.getTreeNodeHierarchy(i).server.version;
+          s_version = pgBrowser.tree.getTreeNodeHierarchy(i).server.version;
 
         // To iterate over tree to check parent node
         while (i) {
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/static/js/index.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/static/js/index.js
index e2c43c627..2d1348305 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/static/js/index.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/static/js/index.js
@@ -124,7 +124,7 @@ define('pgadmin.node.index', [
         var t = pgBrowser.tree, i = item, d = itemData, parents = [],
           immediate_parent_table_found = false,
           is_immediate_parent_table_partitioned = false,
-          s_version = this.getTreeNodeHierarchy(i).server.version;
+          s_version = t.getTreeNodeHierarchy(i).server.version;
         // To iterate over tree to check parent node
         while (i) {
           // Do not allow creating index on partitioned tables.
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/static/js/partition.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/static/js/partition.js
index e2816761c..f3696d7be 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/static/js/partition.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/static/js/partition.js
@@ -116,7 +116,7 @@ function(
         }
 
         info = (_.isUndefined(item) || _.isNull(item)) ?
-          info || {} : this.getTreeNodeHierarchy(item);
+          info || {} : pgBrowser.tree.getTreeNodeHierarchy(item);
 
         return pgadminUtils.sprintf('table/%s/%s/%s/%s/%s/%s',
           encodeURIComponent(type), encodeURIComponent(info['server_group']._id),
@@ -146,7 +146,7 @@ function(
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -188,7 +188,7 @@ function(
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -232,7 +232,7 @@ function(
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -276,7 +276,7 @@ function(
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -294,15 +294,14 @@ function(
                     if (res.success == 1) {
                       Alertify.success(res.info);
                       var n = t.next(i);
-                      if (!n || !n.length) {
+                      if (!n) {
                         n = t.prev(i);
-                        if (!n || !n.length) {
+                        if (!n) {
                           n = t.parent(i);
-                          t.setInode(n, true);
                         }
                       }
                       t.remove(i);
-                      if (n.length) {
+                      if (n) {
                         t.select(n);
                       }
                     }
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/row_security_policies/static/js/row_security_policy.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/row_security_policies/static/js/row_security_policy.js
index b9e3ba0b6..f67396aff 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/row_security_policies/static/js/row_security_policy.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/row_security_policies/static/js/row_security_policy.js
@@ -147,7 +147,7 @@ define('pgadmin.node.row_security_policy', [
       }),
       canCreate: function(itemData, item) {
 
-        var treeData = this.getTreeNodeHierarchy(item),
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
           server = treeData['server'];
 
         // If node is under catalog then do not allow 'create' menu
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js
index 2c1103f4a..42c306174 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js
@@ -140,7 +140,7 @@ define('pgadmin.node.table', [
         /* Enable trigger(s) on table */
         enable_triggers_on_table: function(args) {
           tableFunctions.enableTriggers(
-            pgBrowser.treeMenu,
+            pgBrowser.tree,
             Alertify,
             this.generate_url.bind(this),
             args
@@ -149,7 +149,7 @@ define('pgadmin.node.table', [
         /* Disable trigger(s) on table */
         disable_triggers_on_table: function(args) {
           tableFunctions.disableTriggers(
-            pgBrowser.treeMenu,
+            pgBrowser.tree,
             Alertify,
             this.generate_url.bind(this),
             args
@@ -174,7 +174,7 @@ define('pgadmin.node.table', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -219,7 +219,7 @@ define('pgadmin.node.table', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -263,7 +263,7 @@ define('pgadmin.node.table', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
           if (!d)
             return false;
 
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/static/js/trigger.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/static/js/trigger.js
index 2b9904e0d..2067ce267 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/static/js/trigger.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/static/js/trigger.js
@@ -102,7 +102,7 @@ define('pgadmin.node.trigger', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -140,7 +140,7 @@ define('pgadmin.node.trigger', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
@@ -653,7 +653,7 @@ define('pgadmin.node.trigger', [
       canCreate: SchemaChildTreeNode.isTreeItemOfChildOfSchema,
       // Check to whether trigger is disable ?
       canCreate_with_trigger_enable: function(itemData, item, data) {
-        var treeData = this.getTreeNodeHierarchy(item);
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item);
         if ('view' in treeData) {
           return false;
         }
@@ -663,7 +663,7 @@ define('pgadmin.node.trigger', [
       },
       // Check to whether trigger is enable ?
       canCreate_with_trigger_disable: function(itemData, item, data) {
-        var treeData = this.getTreeNodeHierarchy(item);
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item);
         if ('view' in treeData) {
           return false;
         }
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/static/js/mview.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/static/js/mview.js
index abff525b4..a5e31967d 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/static/js/mview.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/static/js/mview.js
@@ -238,7 +238,7 @@ define('pgadmin.node.mview', [
           obj = this,
           t = pgBrowser.tree,
           i = input.item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined,
+          d = i  ? t.itemData(i) : undefined,
           server_data = null;
 
         if (!d)
@@ -253,7 +253,7 @@ define('pgadmin.node.mview', [
           }
 
           if (pgBrowser.tree.hasParent(j)) {
-            j = $(pgBrowser.tree.parent(j));
+            j = pgBrowser.tree.parent(j);
           } else {
             Alertify.alert(gettext('Please select server or child node from tree.'));
             break;
@@ -316,9 +316,7 @@ define('pgadmin.node.mview', [
       is_version_supported: function(data, item) {
         var t = pgAdmin.Browser.tree,
           i = item || t.selected(),
-          d = data || (i && i.length == 1 ? t.itemData(i): undefined),
-          node = this || (d && pgAdmin.Browser.Nodes[d._type]),
-          info = node && node.getTreeNodeHierarchy.apply(node, [i]),
+          info = t && t.getTreeNodeHierarchy(i),
           version = _.isUndefined(info) ? 0 : info.server.version;
 
         // disable refresh concurrently if server version is 9.3
diff --git a/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js b/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js
index 5485b0183..522cc9035 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js
@@ -106,13 +106,13 @@ define('pgadmin.node.database', [
         );
       },
       can_create_database: function(node, item) {
-        var treeData = this.getTreeNodeHierarchy(item),
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
           server = treeData['server'];
 
         return server.connected && server.user.can_create_db;
       },
       canCreate: function(itemData, item) {
-        var treeData = this.getTreeNodeHierarchy(item),
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
           server = treeData['server'];
 
         // If server is less than 10 then do not allow 'create' menu
@@ -201,7 +201,7 @@ define('pgadmin.node.database', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (d && d.label != 'template0') {
             connect_to_database(obj, d, t, i, true);
@@ -214,7 +214,7 @@ define('pgadmin.node.database', [
             obj = this,
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i  ? t.itemData(i) : undefined;
 
           if (d) {
             Alertify.confirm(
@@ -238,7 +238,6 @@ define('pgadmin.node.database', [
                       data.icon = 'icon-database-not-connected';
                       t.addIcon(i, {icon: data.icon});
                       t.unload(i);
-                      t.setInode(i);
                       setTimeout(function() {
                         t.select(prv_i);
                       }, 10);
@@ -272,7 +271,7 @@ define('pgadmin.node.database', [
           var input = args || {},
             t = pgBrowser.tree,
             i = input.item || t.selected(),
-            d = i && i.length == 1 ? t.itemData(i) : undefined;
+            d = i ? t.itemData(i) : undefined;
           pgBrowser.erd.showErdTool(d, i, true);
         },
 
diff --git a/web/pgadmin/browser/server_groups/servers/databases/subscriptions/static/js/subscription.js b/web/pgadmin/browser/server_groups/servers/databases/subscriptions/static/js/subscription.js
index 0b684ee42..e05002944 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/subscriptions/static/js/subscription.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/subscriptions/static/js/subscription.js
@@ -158,7 +158,7 @@ define('pgadmin.node.subscription', [
           return pgBrowser.DataModel.prototype.sessChanged.apply(this);
         },
         canCreate: function(itemData, item) {
-          var treeData = this.getTreeNodeHierarchy(item),
+          var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
             server = treeData['server'];
 
           // If server is less than 10 then do not allow 'create' menu
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/static/js/pga_job.js b/web/pgadmin/browser/server_groups/servers/pgagent/static/js/pga_job.js
index 8d0641855..083a18074 100644
--- a/web/pgadmin/browser/server_groups/servers/pgagent/static/js/pga_job.js
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/static/js/pga_job.js
@@ -114,7 +114,7 @@ define('pgadmin.node.pga_job', [
           obj = this,
           t = pgBrowser.tree,
           i = input.item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined;
+          d = i  ? t.itemData(i) : undefined;
 
         if (d) {
           $.ajax({
diff --git a/web/pgadmin/browser/server_groups/servers/resource_groups/static/js/resource_group.js b/web/pgadmin/browser/server_groups/servers/resource_groups/static/js/resource_group.js
index bfb32bfec..95a53b03a 100644
--- a/web/pgadmin/browser/server_groups/servers/resource_groups/static/js/resource_group.js
+++ b/web/pgadmin/browser/server_groups/servers/resource_groups/static/js/resource_group.js
@@ -56,7 +56,7 @@ define('pgadmin.node.resource_group', [
            * Resource Group only supported in PPAS 9.4 and above.
            */
           enable: function(node, item) {
-            var treeData = this.getTreeNodeHierarchy(item),
+            var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
               server = treeData['server'];
             return server.connected && node.server_type === 'ppas' &&
               node.version >= 90400;
diff --git a/web/pgadmin/browser/server_groups/servers/roles/static/js/role.js b/web/pgadmin/browser/server_groups/servers/roles/static/js/role.js
index 279371ecc..c18e7c2c1 100644
--- a/web/pgadmin/browser/server_groups/servers/roles/static/js/role.js
+++ b/web/pgadmin/browser/server_groups/servers/roles/static/js/role.js
@@ -46,7 +46,7 @@ define('pgadmin.node.role', [
       hasSQL: true,
       width: '550px',
       canDrop: function(node, item) {
-        var treeData = this.getTreeNodeHierarchy(item),
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
           server = treeData['server'];
           /*
         To Drop a role:
@@ -114,13 +114,13 @@ define('pgadmin.node.role', [
         }]);
       },
       can_create_role: function(node, item) {
-        var treeData = this.getTreeNodeHierarchy(item),
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
           server = treeData['server'];
 
         return server.connected && server.user.can_create_role;
       },
       can_reassign_role: function(node, item) {
-        var treeData = this.getTreeNodeHierarchy(item),
+        var treeData = pgBrowser.tree.getTreeNodeHierarchy(item),
           server = treeData['server'];
 
         return server.connected && node.can_login;
@@ -444,7 +444,7 @@ define('pgadmin.node.role', [
                 if (!_d)
                   return;
                 // Create treeInfo
-                var treeInfo = node.getTreeNodeHierarchy.apply(node, [_i]);
+                var treeInfo = pgBrowser.tree.getTreeNodeHierarchy(_i);
                 // Instance of backbone model
                 var newModel = new RoleReassignObjectModel({}, {node_info: treeInfo}),
                   fields = Backform.generateViewSchema(
